/*==================================================================================================

Copyright (c) 2007 UGS
Unpublished - All rights reserved

====================================================================================================
File description:

Filename: setStringArrayOperationDispatcher.hxx
Module  : extensionframework

This is the root interface class of the setStringArrayOperationDispatcher. It contains of all the generic methods
for setStringArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setStringArrayOperationDispatcher_HXX
#define setStringArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setStringArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setStringArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
public:
    setStringArrayOperationDispatcher();
    virtual ~setStringArrayOperationDispatcher();
    static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setStringArrayPreConditions( Teamcenter::BusinessObject* obj, const std::vector<std::string>& values,  const std::vector<int>* isNullVals ) const;
    void setStringArrayPreActions( Teamcenter::BusinessObject* obj, const std::vector<std::string>& values,  const std::vector<int>* isNullVals  ) const;
    void setStringArrayBaseAction( Teamcenter::BusinessObject* obj, const std::vector<std::string>& values,  const std::vector<int>* isNullVals  ) const;
    void setStringArrayPostActions( Teamcenter::BusinessObject* obj, const std::vector<std::string>& values,  const std::vector<int>* isNullVals  ) const;

    // Project 011450 changes
    void setStringArrayPreConditions( METHOD_message_t* msgData, int num, const char** values,  const logical*  is_null ) const;
    void setStringArrayPreActions( METHOD_message_t* msgData, int num, const char** values,  const logical*  is_null  ) const;
    void setStringArrayPostActions( METHOD_message_t* msgData, int num, const char** values,  const logical*  is_null  ) const;
    void setStringArrayBaseAction( METHOD_message_t* msgData, int num, const char** values,  const logical*  is_null  ) const;

    void setStringArray( Teamcenter::BusinessObject* obj, const std::vector<std::string>& values,  const std::vector<int>* isNullVals  ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setStringArrayOperationDispatcher_HXX
